

(function($) {

    var Element_Ready_Blob_Shape_Widget = function($scope, $) {

        var $blob__wrap  = $scope.find('.er-blob-shape-wrapper');
        $blob__wrap.css({
            width: "400px",
            height : "400px"
        });
       
        let Blob = class Blob {
            constructor(element) {
            this.element = document.querySelector(element);
            this.path = this.element.querySelector('path'); 
            this.pathD = '';
            this.pathCoordinates = {x:0, y:0};
        
            this.radius = 200;
            this.angle = 0;
            this.centerX = 240;
            this.centerY = 240;
            
            this.vertixCountFactor = 0.6;
            this.pathStyle = {
                border:'none',
                fill:'transparent',
                stroke: 'grey',
                strokeWidth: 2, 
                strokeDasharray: "none"
            }
        }
    
        generateCoords() {
            for (let i = 0; i < 2*Math.PI; i+=this.vertixCountFactor) {
                let x = (this.radius*Math.cos(i) + this.centerX) + this.getRandomRadiusModifier();
                let y = (this.radius*Math.sin(i) + this.centerY) + this.getRandomRadiusModifier();
                this.pathCoordinates.push({x,y});
                if (i+this.vertixCountFactor >= 2*Math.PI) {
                this.pathCoordinates.push(this.pathCoordinates[0])
                };
            };
        }
  
        getRandomRadiusModifier() {
        let num = Math.floor(Math.random()*10) + 1;
        num *= Math.floor(Math.random()*2) == 1 ? 1 : -1;
        return num;
        }
  
        drawLinearShape() {
        this.pathD = "M";
        this.pathCoordinates.forEach(coord => {
            this.pathD += `${coord.x},${coord.y} `;
        })
        this.path.setAttribute('d', this.pathD);
        }
  
        resetPathData() {
        this.pathD = "";
        this.pathCoordinates = [];
        }
    
        catmullRom2bezier() {
    
        let d = "";
        this.pathCoordinates.forEach((coord,index, array) => {
            let p = [];
            if (index === 0) {
            d += `M${coord.x},${coord.y} `;
            p.push(array[array.length - 3]);
            p.push(array[index]);
            p.push(array[index+1]);
            p.push(array[index+2]);
            } else if (index === array.length - 2) {
            p.push(array[index-1]);
            p.push(array[index]);
            p.push(array[index+1]);
            p.push(array[0]);
            } else if (index === array.length - 1) {
            return
            } else {
            p.push(array[index-1]);
            p.push(array[index]);
            p.push(array[index+1]);
            p.push(array[index+2]);
            }
            let bp = [];
            bp.push( { x: p[1].x,  y: p[1].y } );
            bp.push( { x: ((-p[0].x + 6*p[1].x + p[2].x) / 6), y: ((-p[0].y + 6*p[1].y + p[2].y) / 6)} );
            bp.push( { x: ((p[1].x + 6*p[2].x - p[3].x) / 6),  y: ((p[1].y + 6*p[2].y - p[3].y) / 6) } );
            bp.push( { x: p[2].x,  y: p[2].y } );
            d += "C" + bp[1].x + "," + bp[1].y + " " + bp[2].x + "," + bp[2].y + " " + bp[3].x + "," + bp[3].y + " ";
    
        })
    
        return d;
        }
  
        drawCurvyShape() {
        this.pathD = this.catmullRom2bezier();
        
        this.path.setAttribute('d', this.pathD);
        }
  
        generateCurvyShape() {
            this.resetPathData();
            this.generateCoords();
            this.drawCurvyShape();
        }
    
      
  
        randomColor() {
            const randomInt = (min, max) => {
                return Math.floor(Math.random() * (max - min + 1)) + min;
            };
            var h = randomInt(0, 360);
            var s = randomInt(42, 98);
            var l = randomInt(40, 90);
            return `hsl(${h},${s}%,${l}%)`;
        }
  
        randomWidth() {
        return Math.floor(Math.random() * Math.floor(50));
        }
  
    };
  
    var b = new Blob(`.er-blob-shape-wrapper[data-id=er_${$scope.data('id')}] svg`);
    b.generateCurvyShape();
  
    }

    $(window).on('elementor/frontend/init', function() {
        
        elementorFrontend.hooks.addAction('frontend/element_ready/Element_Ready_Blob_Widget.default', Element_Ready_Blob_Shape_Widget);
       
    });
})(jQuery);